
package wsrm;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

@WebService()
public class ExactlyOnceInOrder {

    @WebMethod(operationName = "delieverMessage")
    @Oneway
    public void delieverMessage(@WebParam(name = "message") String message) {
        System.out.println("Received RM Client Message - " + message);

        File file = new File("packets-received.out");
        String fileAsString = "";
        if (file.exists()) {
            fileAsString = readFileAsString("packets-received.out");
            fileAsString = fileAsString + message;
        }

        writeToFile("packets-received.out", fileAsString);
    }

    public String readFileAsString(String fileName){
        StringBuffer fileAsStringBuffer = new StringBuffer();
        String line = null;
        BufferedReader fin = null;
        try {
            fin = new BufferedReader(new FileReader(fileName));
            while ((line = fin.readLine()) != null) {
                fileAsStringBuffer.append(line + System.getProperty("line.separator"));
            }
        } catch (Exception ex) {
            String errorMessage = "Error reading file - " + fileName;
            throw new RuntimeException(errorMessage, ex);
        } finally {
            try {
                if (fin != null)
                    fin.close();
            } catch (IOException ioe) {
                String errorMessage = "Unable to file pointer for file - " + fileName;
                throw new RuntimeException(errorMessage, ioe);
            }
        }
        return fileAsStringBuffer.toString();
    }

    public void writeToFile(String fileName, String contents) {
        PrintWriter writer = null;
        try{
            writer = new PrintWriter(new FileWriter(fileName));
            writer.write(contents);
        }catch(Exception ex){
            String errorMessage = "Error when writing File Contents to: " + fileName;
            throw new RuntimeException(errorMessage, ex);
        }finally{
            try{
                writer.close();
            }catch(Exception ex){
                ex.printStackTrace();
            }
        }
    }

}
